/************************************************************************
 *  TEST_INT.C								*
 *			Test von Interrupts				*
 *			===================				*
 *									*
 *  01.04.94	Bodo Wenzel	Erstellung (spezielle Version 51I)	*
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"

/* === Globale Variablen ============================================== */

char	sec100,sec,min,std;

/* === Funktionsprototypen ============================================ */

puts_c(char *s);
str_c(char *s);

timer0_init();
timer0();

/* === M A I N ======================================================== */

main()
/*--*/
  {
  char l[10];

  getchar();
  puts_c("Programm gestartet...\r\n");
  timer0_init();
  puts_c("Uhr gestartet...\r\n");
  for (;;) {
    sprintf(l,str_c("%2d:"),std);
    puts(l);
    sprintf(l,str_c("%02d:"),min);
    puts(l);
    sprintf(l,str_c("%02d."),sec);
    puts(l);
    sprintf(l,str_c("%02d\r\n"),sec100);
    puts(l);
    }
  }

/* === Unterfunktionen ================================================ */

puts_c(char *s)
/*-----------*/
  {
  char	c;

  while (c=s++
#asm
	mov	dph,b
	mov	dpl,a
	clr	a
	mov	b,a
	movc	a,@a+dptr
#endasm
	    )
    putchar(c);
  }

char	str[10];

str_c(char *s)
/*----------*/
  {
  char	*p;

  p=str;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str);
  }

timer0_init()
/*---------*/
  {
#asm
timer0	equ	quarz/12/100

	anl	TMOD,#0F0H
	orl	TMOD,#001H
	mov	TH0,#high(-timer0+5)
	mov	TL0,#low(-timer0+5)
	clr	TF0
	setb	ET0
	setb	EA
	setb	TR0
#endasm
  sec100=0;
  sec=0;
  min=0;
  std=0;
  }

timer0()
/*----*/
  {
#asm
	push	acc
	push	psw

	clr	TR0
	mov	TH0,#high(-timer0+5)
	mov	TL0,#low(-timer0+5)
	setb	TR0

	inc	ccsec100
	mov	a,ccsec100
	xrl	a,#100
	jnz	_timer0_01
	mov	ccsec100,a

	inc	ccsec
	mov	a,ccsec
	xrl	a,#60
	jnz	_timer0_01
	mov	ccsec,a

	inc	ccmin
	mov	a,ccmin
	xrl	a,#60
	jnz	_timer0_01
	mov	ccmin,a

	inc	ccstd
	mov	a,ccstd
	xrl	a,#24
	jnz	_timer0_01
	mov	ccstd,a

_timer0_01:
	pop	psw
	pop	acc
#endasm
  }

/* === Unbenutzte Interrupts ========================================== */

int0()		{ }
int1()		{ }
timer1()	{ }
sio()		{ }

/* === Ende =========================================================== */
