/************************************************************************
 *  TEST_ALU.C								*
 *			Test von Arithmetik und Logik			*
 *			=============================			*
 *									*
 *  02.04.94	Bodo Wenzel	Erstellung (spezielle Version 51X)	*
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"

/* === Funktionsprototypen ============================================ */

puts_c(char *s);

arith(int i1,int i2);
logic(int i1,int i2);
log_int(int i1,int i2);
log_ptr(char *p1,char *p2);
log(int l);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  char	*pc;
  int	*pi;

  getchar();

  for (;;)
    {
    puts_c("Gestartet...\r\n");

    arith(0x123,0x456);
    arith(0x456,0x123);
    arith(1,0);
    arith(0,1);
    arith(1,1);
    arith(32767,1);
    arith(1,32767);
    arith(32767,32767);

    logic(0x123,0x456);
    logic(0x456,0x123);
    logic(1,32767);

    puts_c("\r\n123<<4=");
    hex(0x123<<4);
    puts_c("\r\n123>>4=");
    hex(0x123>>4);
    pc=0x123;
    puts_c("\r\n++123=");
    hex(++pc);
    puts_c("\r\n--124=");
    hex(--pc);
    puts_c("\r\n123++=");
    hex(pc++);
    puts_c("\r\n124--=");
    hex(pc--);
    pi=0x456;
    puts_c("\r\n++456=");
    hex(++pi);
    puts_c("\r\n--45x=");
    hex(--pi);
    puts_c("\r\n456++=");
    hex(pi++);
    puts_c("\r\n45x--=");
    hex(pi--);
    getchar();

    log_int(0,1);
    log_int(0,-1);
    log_int(1,0);
    log_int(-1,0);
    log_int(1,1);

    log_ptr(0,1);
    log_ptr(0,-1);
    log_ptr(1,0);
    log_ptr(-1,0);
    log_ptr(1,1);
    puts_c("\r\n");
    }
  }

/* === Hilfsfunktionen ================================================ */

puts_c(char *s)
/*-----------*/
  {
  char	c;

  while (c=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    )
    putchar(c);
  }

/* === Arithmetik ===================================================== */

arith(int i1,int i2)
/*----------------*/
  {
  puts_c("\r\nArithmetik mit ");
  hex(i1);
  puts_c(" und ");
  hex(i2);
  puts_c(":\r\nAddition:       ++=");
  hex(i1 + i2);
  puts_c(" +-=");
  hex(i1 + -i2);
  puts_c(" -+=");
  hex(-i1 + i2);
  puts_c(" --=");
  hex(-i1 + -i2);
  puts_c("\r\nSubtraktion:    ++=");
  hex(i1 - i2);
  puts_c(" +-=");
  hex(i1 - -i2);
  puts_c(" -+=");
  hex(-i1 - i2);
  puts_c(" --=");
  hex(-i1 - -i2);
  puts_c("\r\nMultiplikation: ++=");
  hex(i1 * i2);
  puts_c(" +-=");
  hex(i1 * -i2);
  puts_c(" -+=");
  hex(-i1 * i2);
  puts_c(" --=");
  hex(-i1 * -i2);
  if (i2==0)
    puts_c("\r\nDivision und Modulo: Teiler=0!");
  else
    {
    puts_c("\r\nDivision:	++=");
    hex(i1 / i2);
    puts_c(" +-=");
    hex(i1 / -i2);
    puts_c(" -+=");
    hex(-i1 / i2);
    puts_c(" --=");
    hex(-i1 / -i2);
    puts_c("\r\nModulo: 	++=");
    hex(i1 % i2);
    puts_c(" +-=");
    hex(i1 % -i2);
    puts_c(" -+=");
    hex(-i1 % i2);
    puts_c(" --=");
    hex(-i1 % -i2);
    }
  getchar();
  }

/* === Logik ========================================================== */

logic(int i1,int i2)
/*----------------*/
  {
  puts_c("\r\nLogik mit ");
  hex(i1);
  putchar('/');
  hex(-i1);
  puts_c(" und ");
  hex(i2);
  putchar('/');
  hex(-i2);
  puts_c(":\r\nDisjunktion:   ++=");
  hex(i1 | i2);
  puts_c(" +-=");
  hex(i1 | -i2);
  puts_c(" -+=");
  hex(-i1 | i2);
  puts_c(" --=");
  hex(-i1 | -i2);
  puts_c("\r\nExclusiv-Oder: ++=");
  hex(i1 ^ i2);
  puts_c(" +-=");
  hex(i1 ^ -i2);
  puts_c(" -+=");
  hex(-i1 ^ i2);
  puts_c(" --=");
  hex(-i1 ^ -i2);
  puts_c("\r\nKonjunktion:   ++=");
  hex(i1 & i2);
  puts_c(" +-=");
  hex(i1 & -i2);
  puts_c(" -+=");
  hex(-i1 & i2);
  puts_c(" --=");
  hex(-i1 & -i2);
  getchar();
  }

log_int(int i1,int i2)
/*------------------*/
  {
  puts_c("\r\nWerte, vergleiche ");
  hex(i1);
  puts_c(" mit ");
  hex(i2);
  puts_c(":\r\n==:");
  log(i1==i2);
  puts_c("\r\n!=:");
  log(i1!=i2);
  puts_c("\r\n<:");
  log(i1<i2);
  puts_c("\r\n<=:");
  log(i1<=i2);
  puts_c("\r\n>:");
  log(i1>i2);
  puts_c("\r\n>=:");
  log(i1>=i2);
  getchar();
  }

log_ptr(char *p1,char *p2)
/*----------------------*/
  {
  puts_c("\r\nPointer, vergleiche ");
  hex(p1);
  puts_c(" mit ");
  hex(p2);
  puts_c(":\r\n==:");
  log(p1==p2);
  puts_c("\r\n!=:");
  log(p1!=p2);
  puts_c("\r\n<:");
  log(p1<p2);
  puts_c("\r\n<=:");
  log(p1<=p2);
  puts_c("\r\n>:");
  log(p1>p2);
  puts_c("\r\n>=:");
  log(p1>=p2);
  getchar();
  }

log(int l)
/*------*/
  {
  if (l)
    puts_c("wahr");
  else
    puts_c("falsch");
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  putchar('(');
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>12);
  nib(n>>8);
  nib(n>>4);
  nib(n);
  putchar(')');
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
