/************************************************************************
 *  TEST_ST1.C								*
 *			Test von STRING-Funktionen (Teil 1)		*
 *			===================================		*
 *									*
 *  02.04.94	Bodo Wenzel	Erstellung (spezielle Version 51X)	*
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "string.h"

/* === Funktionsprototypen ============================================ */

puts_c(char *s);
str_c1(char *s);
str_c2(char *s);

cpy(char *s);
ncpy(char *s,int i);
cat(char *s);
ncat(char *s,int i);
cmp(char *s1,char *s2);
ncmp(char *s1,char *s2,int i);

ssi(char *s1,char *s2,int i);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  char	s1[100];

  getchar();

  for (;;)
    {
    puts_c("Gestartet...\r\n");

    cpy(str_c1(""));
    cpy(str_c1("1"));
    cpy(str_c1("Teststring1"));
    getchar();

    ncpy(str_c1(""),4);
    ncpy(str_c1("1"),4);
    ncpy(str_c1("Teststring1"),4);
    getchar();

    cat(str_c1(""));
    cat(str_c1("2"));
    cat(str_c1("Teststring2"));
    getchar();

    ncat(str_c1(""),4);
    ncat(str_c1("2"),4);
    ncat(str_c1("Teststring2"),4);
    getchar();

    cmp(str_c1(""),str_c2(""));
    cmp(str_c1("x"),str_c2(""));
    cmp(str_c1(""),str_c2("x"));
    cmp(str_c1("Teststring"),str_c2("Teststring"));
    cmp(str_c1("Teststring1"),str_c2("Teststring"));
    cmp(str_c1("Teststring"),str_c2("Teststring2"));
    getchar();

    ncmp(str_c1(""),str_c2(""),10);
    ncmp(str_c1("x"),str_c2(""),10);
    ncmp(str_c1(""),str_c2("x"),10);
    ncmp(str_c1("Teststring"),str_c2("Teststring"),10);
    ncmp(str_c1("Teststring1"),str_c2("Teststring"),10);
    ncmp(str_c1("Teststring"),str_c2("Teststring2"),10);
    ncmp(str_c1("Teststring"),str_c2("Teststring"),11);
    ncmp(str_c1("Teststring1"),str_c2("Teststring"),11);
    ncmp(str_c1("Teststring"),str_c2("Teststring2"),11);
    ncmp(str_c1("Teststring1"),str_c2("Teststring2"),11);
    ncmp(str_c1("Teststring2"),str_c2("Teststring2"),11);
    getchar();
    }
  }

/* === Hilfsfunktionen ================================================ */

puts_c(char *s)
/*-----------*/
  {
  char	c;

  while (c=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    )
    putchar(c);
  }

char	str1[100],str2[100];

str_c1(char *s)
/*-----------*/
  {
  char	*p;

  p=str1;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str1);
  }

str_c2(char *s)
/*-----------*/
  {
  char	*p;

  p=str2;
  while (*p++=s++
#asm
	mov	dph,b
	mov	dpl,a
	mov	b,#0
	clr	a
	movc	a,@a+dptr
#endasm
	    );
  return(str2);
  }

/* === Stringfunktionen =============================================== */

cpy(char *s)
/*--------*/
  {
  char	b[100];

  strcpy(b,str_c2("******************************"));
  strcpy(b,s);
  putchar('"');
  puts(s);
  puts_c("\"=>\"");
  puts(b);
  puts_c("\"\r\n");
  }

ncpy(char *s,int i)
/*---------------*/
  {
  char	b[100];

  strcpy(b,str_c2("******************************"));
  strncpy(b,s,i);
  putchar('"');
  puts(s);
  puts_c("\"(");
  hex(i);
  puts_c(")=>\"");
  puts(b);
  puts_c("\"\r\n");
  }

cat(char *s)
/*--------*/
  {
  char	b[100];

  strcpy(b,str_c2("Teststring1"));
  strcat(b,s);
  puts_c("\"Teststring1\"+\"");
  puts(s);
  puts_c("\"=>\"");
  puts(b);
  puts_c("\"\r\n");
  }

ncat(char *s,int i)
/*---------------*/
  {
  char	b[100];

  strcpy(b,str_c2("Teststring1"));
  strncat(b,s,i);
  puts_c("\"Teststring1\"+\"");
  puts(s);
  puts_c("\"(");
  hex(i);
  puts_c(")=>\"");
  puts(b);
  puts_c("\"\r\n");
  }

cmp(char *s1,char *s2)
/*------------------*/
  {
  int	i;

  i=strcmp(s1,s2);
  ssi(s1,s2,i);
  puts_c("\r\n");
  }

ncmp(char *s1,char *s2,int i)
/*-------------------------*/
  {
  int	j;

  j=strncmp(s1,s2,i);
  ssi(s1,s2,i);
  putchar('(');
  hex(j);
  puts_c(")\r\n");
  }

/* === Ausgabefunktionen ============================================== */

ssi(char *s1,char *s2,int i)
/*------------------------*/
  {
  puts_c("\"");
  puts(s1);
  puts_c("\"<=>\"");
  puts(s2);
  puts_c("\":");
  hex(i);
  }

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
