/************************************************************************
 *  SPRINTF.C                                                           *
 *                  STDIO-Funktion sprintf() (fr PINC)                 *
 *                  ===================================                 *
 *                                                                      *
 *  15.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

#include "ctype.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

/* -------------------------------------------------------------------- */
/*      sprintf()       formatiert einen Ausgabewert, liefert die       */
/*                      Anzahl der ausgegebenen Zeichen                 */
/*      s               Zeiger auf den Zielpuffer                       */
/*      format          Zeiger auf die Formatangabe                     */
/*      arg             (als int vereinbart) das Argument               */

sprintf(char *s,char *format,int arg)
/*---------------------------------*/
  {
  char  *p,*q,c;
  int   left,fill,width,len;

  p=s;
  while (*format)
    {
    if (*format!='%')
      {
      *p++=*format++;
      continue;
      }
    if (*++format=='%')
      {
      *p++='%';
      ++format;
      continue;
      }
    if (left=*format=='-')
      ++format;
    if (*format=='0')
      fill='0';
    else
      fill=' ';
    width=0;
    if (isdigit(*format))
      {
      len=0;
      width=strtoi(format,10,&len);
      format=format+len;
      }
    if ((c=*format++)=='\0')
      break;
    switch (c)
      {
      case 'd':
        itostr(p,10,arg);
        break;
      case 'x':
        itostr(p,16,arg);
        break;
      case 'c':
        *p=arg;
        *(p+1)='\0';
        break;
      case 's':
        strcpy(p,arg);
        break;
      default:
        *p='\0';
      }
    len=strlen(p);
    q=p+width;
    p=p+len;
    if (len<width)
      {
      if (left)
        while (p<q)
          *p++=fill;
      else
        {
        while (--len>=0)
          *--q=*--p;
        while (q>p)
          *--q=fill;
        p=p+width;
        }
      }
    }
  *p='\0';
  return(p-s);
  }

/* === Ende =========================================================== */
