/************************************************************************
 *  TEST_PRT.C                                                          *
 *                      Test der sprintf()-Funktion                     *
 *                      ===========================                     *
 *                                                                      *
 *  17.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "string.h"

/* === Funktionsprototypen ============================================ */

prt_i(char *f,int v);
prt_p(char *f,char *p);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  prt_i("",0);
  prt_i("%",0);
  prt_i("Teststring",0);
  prt_i("%% %?",0);
  getchar();

  prt_p("%s","Test");
  prt_p("%-s","Test");
  prt_p("%5s","Test");
  prt_p("%-5s","Test");
  prt_p("%0s","Test");
  prt_p("%-0s","Test");
  prt_p("%05s","Test");
  prt_p("%-05s","Test");
  getchar();

  prt_i("%d",1);
  prt_i("%x",1);
  prt_i("%c",1);
  getchar();

  prt_i("%d",-123);
  prt_i("%x",-123);
  prt_i("%c",-123);
  getchar();

  prt_i("%d",123);
  prt_i("%x",123);
  prt_i("%c",123);
  getchar();

  prt_i("%-d",123);
  prt_i("%-x",123);
  prt_i("%-c",123);
  getchar();

  prt_i("%5d",123);
  prt_i("%5x",123);
  prt_i("%5c",123);
  getchar();

  prt_i("%-5d",123);
  prt_i("%-5x",123);
  prt_i("%-5c",123);
  getchar();

  prt_i("%0d",123);
  prt_i("%0x",123);
  prt_i("%0c",123);
  getchar();

  prt_i("%-0d",123);
  prt_i("%-0x",123);
  prt_i("%-0c",123);
  getchar();

  prt_i("%05d",123);
  prt_i("%05x",123);
  prt_i("%05c",123);
  getchar();

  prt_i("%-05d",123);
  prt_i("%-05x",123);
  prt_i("%-05c",123);
  getchar();

  prt_p("%d 0x%x \"%s\" '%c'","Test");
  return(0);
  }

/* === Test von sprintf() ============================================= */

prt_i(char *f,int v)
/*----------------*/
  {
  char  s[100];
  int   i;

  strcpy(s,"******************************");
  i=sprintf(s,f,v);
  putchar('"');
  puts(f);
  puts("\"(");
  hex(v);
  puts(")=>(");
  hex(i);
  puts(")\"");
  puts(s);
  puts("\"\r\n");
  }

prt_p(char *f,char *p)
/*------------------*/
  {
  char  s[100];
  int   i;

  strcpy(s,"******************************");
  i=sprintf(s,f,p);
  putchar('"');
  puts(f);
  puts("\"(\"");
  puts(p);
  puts("\")=>(");
  hex(i);
  puts(")\"");
  puts(s);
  puts("\"\r\n");
  }

/* === Ausgabefunktionen ============================================== */

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
