/************************************************************************
 *  TEST_STR.C                                                          *
 *                      Test von STRING-Funktionen                      *
 *                      ==========================                      *
 *                                                                      *
 *  14.06.93    Bodo Wenzel     Erstellung                              *
 ************************************************************************/

/* === Einfgedateien ================================================= */

#include "stdio.h"
#include "string.h"

/* === Funktionsprototypen ============================================ */

cpy(char *s);
ncpy(char *s,int i);
cat(char *s);
ncat(char *s,int i);
cmp(char *s1,char *s2);
ncmp(char *s1,char *s2,int i);
chr(char *s,char c);
rchr(char *s,char c);
len(char *s);
rev(char *s);

ssi(char *s1,char *s2,int i);
show(char *s1,char *s2);
hex(int n);
nib(int n);

/* === M A I N ======================================================== */

main()
/*--*/
  {
  char  s1[100];

  cpy("");
  cpy("1");
  cpy("Teststring1");
  getchar();

  ncpy("",4);
  ncpy("1",4);
  ncpy("Teststring1",4);
  getchar();

  cat("");
  cat("2");
  cat("Teststring2");
  getchar();

  ncat("",4);
  ncat("2",4);
  ncat("Teststring2",4);
  getchar();

  cmp("","");
  cmp("x","");
  cmp("","x");
  cmp("Teststring","Teststring");
  cmp("Teststring1","Teststring");
  cmp("Teststring","Teststring2");
  getchar();

  ncmp("","",10);
  ncmp("x","",10);
  ncmp("","x",10);
  ncmp("Teststring","Teststring",10);
  ncmp("Teststring1","Teststring",10);
  ncmp("Teststring","Teststring2",10);
  ncmp("Teststring","Teststring",11);
  ncmp("Teststring1","Teststring",11);
  ncmp("Teststring","Teststring2",11);
  ncmp("Teststring1","Teststring2",11);
  ncmp("Teststring2","Teststring2",11);
  getchar();

  strcpy(s1,"Teststring");
  puts("--->\"");
  puts(s1);
  puts("\"\r\n");
  chr(s1,'T');
  chr(s1,'s');
  chr(s1,'g');
  chr(s1,'x');
  getchar();

  puts("--->\"");
  puts(s1);
  puts("\"\r\n");
  rchr(s1,'T');
  rchr(s1,'s');
  rchr(s1,'g');
  rchr(s1,'x');
  getchar();

  len("");
  len("x");
  len("Teststring");
  getchar();

  rev("");
  rev("x");
  rev("Teststring");
  getchar();
  return(0);
  }

/* === Stringfunktionen =============================================== */

cpy(char *s)
/*--------*/
  {
  char  b[100];

  strcpy(b,"******************************");
  strcpy(b,s);
  putchar('"');
  puts(s);
  puts("\"=>\"");
  puts(b);
  puts("\"\r\n");
  }

ncpy(char *s,int i)
/*---------------*/
  {
  char  b[100];

  strcpy(b,"******************************");
  strncpy(b,s,i);
  putchar('"');
  puts(s);
  puts("\"(");
  hex(i);
  puts(")=>\"");
  puts(b);
  puts("\"\r\n");
  }

cat(char *s)
/*--------*/
  {
  char  b[100];

  strcpy(b,"Teststring1");
  strcat(b,s);
  puts("\"Teststring1\"+\"");
  puts(s);
  puts("\"=>\"");
  puts(b);
  puts("\"\r\n");
  }

ncat(char *s,int i)
/*---------------*/
  {
  char  b[100];

  strcpy(b,"Teststring1");
  strncat(b,s,i);
  puts("\"Teststring1\"+\"");
  puts(s);
  puts("\"(");
  hex(i);
  puts(")=>\"");
  puts(b);
  puts("\"\r\n");
  }

cmp(char *s1,char *s2)
/*------------------*/
  {
  int   i;

  i=strcmp(s1,s2);
  ssi(s1,s2,i);
  puts("\r\n");
  }

ncmp(char *s1,char *s2,int i)
/*-------------------------*/
  {
  int   j;

  j=strncmp(s1,s2,i);
  ssi(s1,s2,i);
  putchar('(');
  hex(j);
  puts(")\r\n");
  }

chr(char *s,char c)
/*---------------*/
  {
  char  *p;

  p=strchr(s,c);
  putchar('\'');
  putchar(c);
  puts("'>");
  show(s,p);
  }

rchr(char *s,char c)
/*----------------*/
  {
  char  *p;

  p=strrchr(s,c);
  putchar('\'');
  putchar(c);
  puts("'>");
  show(s,p);
  }

len(char *s)
/*--------*/
  {
  int   i;

  i=strlen(s);
  puts("len\"");
  puts(s);
  puts("\":");
  hex(i);
  puts("\r\n");
  }

rev(char *s)
/*--------*/
  {
  char  b[100];

  strcpy(b,s);
  reverse(b);
  puts("\"");
  puts(s);
  puts("\"~\"");
  puts(b);
  puts("\"\r\n");
  }

/* === Ausgabefunktionen ============================================== */

ssi(char *s1,char *s2,int i)
/*------------------------*/
  {
  puts("\"");
  puts(s1);
  puts("\"<=>\"");
  puts(s2);
  puts("\":");
  hex(i);
  }

show(char *s1,char *s2)
/*-------------------*/
  {
  if (s2==NULL)
    puts("0\r\n");
  else
    {
    while (s2-->=s1)
      putchar(' ');
    puts("^\r\n");
    }
  }

hex(int n)
/*------*/
  {
  if (n<0)
    {
    n=-n;
    putchar('-');
    }
  else
    putchar('+');
  nib(n>>4);
  nib(n);
  }

nib(int n)
/*------*/
  {
  n=n&15;
  if (n<10)
    putchar(n+'0');
  else
    putchar(n-10+'A');
  }

/* === Ende =========================================================== */
